package com.io.yutian.auchestshop.command.subs;

import com.io.yutian.auchestshop.AuChestShop;
import com.io.yutian.auchestshop.shop.Shop;
import com.io.yutian.auchestshop.shop.ShopLocation;
import com.io.yutian.auchestshop.shop.ShopType;
import com.io.yutian.auchestshop.shop.log.ShopLog;
import com.io.yutian.aulib.command.CommandContext;
import com.io.yutian.aulib.command.ICommand;
import com.io.yutian.aulib.command.argument.Argument;
import com.io.yutian.aulib.command.argument.ArgumentTypes;
import org.bukkit.command.CommandSender;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class CommandTest extends ICommand {

    public CommandTest() {
        super("test");
        addArgument(Argument.argument("type", ArgumentTypes.STRING));
    }

    private static List<Shop> shops = new ArrayList<>();

    @Override
    public void executes(CommandContext commandContext) {
        CommandSender sender = commandContext.getSender();
        String type = commandContext.getArgumentsValue("type").getString();
        if (type.equalsIgnoreCase("create")) {
            Shop shop = new Shop(UUID.randomUUID(), UUID.randomUUID(), new ShopLocation("world", 0, 10, 0), null, 10, ShopType.BUYING, false, new ShopLog());
            shops.add(shop);
            sender.sendMessage("Shop created!");
        } else if (type.equalsIgnoreCase("save")) {
            AuChestShop.getSQLIO().saveAllShops(shops);
            sender.sendMessage("Shop saved!");
        } else if (type.equalsIgnoreCase("list")) {
            System.out.println(shops);
            for (Shop shop : shops) {
                sender.sendMessage(shop.getUUID());
                sender.sendMessage(shop.getOwner());
            }
        } else if (type.equalsIgnoreCase("load")) {
            shops = AuChestShop.getSQLIO().loadAllShops();
            System.out.println(shops);
            sender.sendMessage("Loaded all shops!");
        }
    }

}
