package com.io.yutian.auchestshop.shop;

import org.bukkit.Location;
import org.bukkit.World;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;

public class ShopChunk {

    private final String world;
    private final int x;
    private final int z;

    public ShopChunk(String world, int x, int z) {
        this.world = world;
        this.x = x;
        this.z = z;
    }

    public String getWorld() {
        return world;
    }

    public int getX() {
        return x;
    }

    public int getZ() {
        return z;
    }

    public boolean equals(@NotNull String world, int x, int z) {
        return this.x == x && this.z == z && this.world.equals(world);
    }

    public boolean equals(@NotNull World world, int x, int z) {
        return equals(world.getName(), x, z);
    }


    public static ShopChunk fromLocation(@NotNull Location location) {
        return new ShopChunk(location.getWorld().getName(), location.getBlockX() >> 4, location.getBlockZ() >> 4);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        ShopChunk shopChunk = (ShopChunk) o;
        return getX() == shopChunk.getX() && getZ() == shopChunk.getZ() && Objects.equals(getWorld(), shopChunk.getWorld());
    }

    @Override
    public int hashCode() {
        int result = Objects.hashCode(getWorld());
        result = 31 * result + getX();
        result = 31 * result + getZ();
        return result;
    }

}
