package com.io.yutian.auchestshop.shop;

import org.json.JSONObject;

public class ShopLocation {

    private final String world;
    private final int x;
    private final int y;
    private final int z;

    public ShopLocation(String world, int x, int y, int z) {
        this.world = world;
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public static ShopLocation fromJSON(JSONObject json) {
        return new ShopLocation(json.getString("world"), json.getInt("x"), json.getInt("y"), json.getInt("z"));
    }

    public JSONObject toJSON() {
        JSONObject json = new JSONObject();
        json.put("world", world);
        json.put("x", x);
        json.put("y", y);
        json.put("z", z);
        return json;
    }

    public String getWorld() {
        return world;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public int getZ() {
        return z;
    }

}
