package com.io.yutian.auchestshop.shop.log;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class ShopLog {

    private double total;
    private List<ShopPlayerLog> playerLogs;

    public ShopLog() {
        this(0, new ArrayList<>());
    }

    public ShopLog(double total, List<ShopPlayerLog> playerLogs) {
        this.total = total;
        this.playerLogs = playerLogs;
    }

    public double getTotal() {
        return total;
    }

    public void setTotal(double total) {
        this.total = total;
    }

    public void addPlayerLog(ShopPlayerLog playerLog) {
        this.playerLogs.add(playerLog);
    }

    public List<ShopPlayerLog> getPlayerLogs() {
        return playerLogs;
    }

    public static ShopLog fromJSON(JSONObject jsonObject) {
        double total = jsonObject.getDouble("total");
        JSONArray playerLogsArray = jsonObject.getJSONArray("playerLogs");
        List<ShopPlayerLog> shopPlayerLogs = new ArrayList<>();
        for (int i = 0; i < playerLogsArray.length(); i++) {
            JSONObject playerLogObject = playerLogsArray.getJSONObject(i);
            ShopPlayerLog playerLog = ShopPlayerLog.fromJSON(playerLogObject);
            shopPlayerLogs.add(playerLog);
        }
        return new ShopLog(total, shopPlayerLogs);
    }

    public JSONObject toJSON() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("total", total);
        JSONArray playerLogsArray = new JSONArray();
        for (ShopPlayerLog playerLog : playerLogs) {
            JSONObject playerLogJson = playerLog.toJSON();
            playerLogsArray.put(playerLogJson);
        }
        jsonObject.put("playerLogs", playerLogsArray);
        return jsonObject;
    }
}
